import { arc } from 'd3';

export const Marks = ({
  data,
  xScale,
  yScale,
  xValue,
  yValue,
  tooltipFormat
}) => {

  let totalDeaths = 0;
  let totalMaleFirearmDeaths = 0;
  let totalFemaleFirearmDeaths = 0;
  let totalMaleSuicideDeaths = 0;
  let totalFemaleSuicideDeaths = 0;
  let totalMaleAlcoholDeaths = 0;
  let totalFemaleAlcoholDeaths = 0;
  
	console.log(data);
	data.forEach(element => {
    	totalDeaths += element.TotalDeaths;
    	if (element.Sex === "M") {
        totalMaleFirearmDeaths += element.FirearmDeaths;
        totalMaleSuicideDeaths += element.SuicideDeaths;
        totalMaleAlcoholDeaths += element.AlcoholRelatedDeaths;
      } else if (element.Sex === "F") {
        totalFemaleFirearmDeaths += element.FirearmDeaths;
        totalFemaleSuicideDeaths += element.SuicideDeaths;
        totalFemaleAlcoholDeaths += element.AlcoholRelatedDeaths;
      }
  });
  let totalMaleSet = [totalMaleFirearmDeaths, totalMaleSuicideDeaths, totalMaleAlcoholDeaths];
  let totalFemaleSet = [totalFemaleFirearmDeaths, totalFemaleSuicideDeaths, totalFemaleAlcoholDeaths];
	let totalFirearmSet = [totalMaleFirearmDeaths, totalFemaleFirearmDeaths];
  let totalSuicideSet = [totalMaleSuicideDeaths, totalFemaleSuicideDeaths];
  let totalAlcoholSet = [totalMaleAlcoholDeaths, totalFemaleAlcoholDeaths];
  
  
  let startPercent = 0;
  let sizePercent = 0.1; // in percentage
  // Total circum is 2pi
  let percentToRadian = Math.PI * 2;
  
  
  let colors = ["#FF0000", "#0000FF", "#00FF00"];
  let colorIndex = -1;
  
  // let totalDenom = totalDeaths;
  // let totalSet = [];
  
  let totalDenom = totalMaleFirearmDeaths + totalMaleSuicideDeaths + totalMaleAlcoholDeaths;
  let totalSet = totalMaleSet;
  let labels = ["Firearm", "Suicide", "Alcohol"];
  
  
  return totalSet.map(d => {
    // increment starting at -1
    colorIndex++;
    
    // calculate piece size
    console.log(d);
    sizePercent = d / totalDenom;
    
    // declare function with params
    const mouthArc = arc()
    	.innerRadius(80)
			.outerRadius(120)
  		.startAngle(startPercent * percentToRadian)
			.endAngle((startPercent * percentToRadian) + (sizePercent * percentToRadian));
    
    // update start angle
    startPercent = startPercent + sizePercent;
    
    let textX = 140*Math.sin(startPercent*percentToRadian);
    let textY = 140*Math.cos(startPercent*percentToRadian);
    let offsetX = -30;
    let offsetY = 160;
    
    // return the value
    return <g
      >
        <path
          d={mouthArc()} 
          fill={colors[colorIndex]}
          transform={`translate(${offsetX},${offsetY})`}
      />
      <text
        transform={`translate(${offsetX+textX},${offsetY+textY})`}
      >
        {labels[colorIndex]}
      </text>
      </g>;
  });
  
};
